<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="公式名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入公式名称" />
      </el-form-item>
      <el-form-item label="公式编号" prop="formulaCode">
        <el-input v-model="formData.formulaCode" placeholder="请输入公式编号" />
      </el-form-item>
      <el-form-item label="公式" prop="formula">
        <el-input v-model="formData.formula" placeholder="请输入公式" />
      </el-form-item>
      <el-form-item label="结果含义" prop="resultType">
        <el-radio-group v-model="formData.resultType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_DATA_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="机台ID" prop="machineId">
        <el-input v-model="formData.machineId" placeholder="请输入机台ID" />
      </el-form-item>
      <el-form-item label="单位" prop="dataUnit">
        <el-input v-model="formData.dataUnit" placeholder="请输入单位" />
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" type="textarea" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="是否启用" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import {getStrDictOptions, DICT_TYPE, getBoolDictOptions} from '@/utils/dict'
import { FormulaApi, FormulaVO } from '@/api/iot/formula'

/** 计算公式 表单 */
defineOptions({ name: 'FormulaForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  formulaCode: undefined,
  formula: undefined,
  resultType: undefined,
  machineId: undefined,
  remark: undefined,
  isEnable: undefined,
})
const formRules = reactive({
  machineId: [{ required: true, message: '机台ID不能为空', trigger: 'blur' }],
  isEnable: [{ required: true, message: '是否启用不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await FormulaApi.getFormula(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as FormulaVO
    if (formType.value === 'create') {
      await FormulaApi.createFormula(data)
      message.success(t('common.createSuccess'))
    } else {
      await FormulaApi.updateFormula(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    formulaCode: undefined,
    formula: undefined,
    resultType: undefined,
    machineId: undefined,
    remark: undefined,
    isEnable: undefined,
  }
  formRef.value?.resetFields()
}
</script>
